# ansible/deploy_land.yml

# ========================
# IRISA Platform License
# ========================

# Copyright (c) [2024] [IRISA, Université de Rennes]

# This file is part of IRISA Platform.

# IRISA Platform is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, Version 3 of the License.

# IRISA Platform is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

# You should have received a copy of the GNU General Public License along with IRISA Platform. If not, see <https://www.gnu.org/licenses/>.

---
- hosts: all
  any_errors_fatal: true
  gather_facts: no
  vars:
      ansible_host: "{{ lookup('env', 'HOST_IP_LAND') }}"
      ansible_ssh_user: "{{ lookup('env','LAND_SSH_USER') }}"
      ansible_ssh_pass: "{{ lookup('env','LAND_SSH_PASS') }}"
      ansible_ssh_extra_args: '-o StrictHostKeyChecking=no'

      HOST_IP_LAND: "{{ lookup('env', 'HOST_IP_LAND') }}"
      LAND_SSH_USER: "{{ lookup('env','LAND_SSH_USER') }}"
      LAND_SSH_PASS: "{{ lookup('env','LAND_SSH_PASS') }}"
      HOST_IP_BOAT: "{{ lookup('env', 'HOST_IP_BOAT') }}"
      HOST_HOSTNAME_LAND: "{{ lookup('env', 'HOST_HOSTNAME_LAND') }}"
      HOST_HOSTNAME_BOAT: "{{ lookup('env', 'HOST_HOSTNAME_BOAT') }}"
      HOST_IP_RPC: "{{ lookup('env', 'HOST_IP_RPC') }}"

      openvpn_admin_username: 'openvpn'
      openvpn_admin_password: 'IRISA@2025!'
      openvpn_user1_username: 'work'
      openvpn_user1_password: 'IRISA@2024!'
      openvpn_user1_ip: '10.10.10.10'
      openvpn_user2_username: 'works'
      openvpn_user2_password: 'IRISA@2024!'
      openvpn_user2_ip: '10.10.10.20'
  tasks:
      - name: Test connectivity
        block:
            - name: Ensure sshpass is installed
              become: yes
              package:
                  name: sshpass
                  state: present
              when: "'boat_group' in group_names"

            # - name: Ensure git is installed
            #   become: yes
            #   package:
            #       name: git
            #       state: present

            - name: Ping all hosts
              ping:
              register: result
              ignore_errors: false

            - name: Fail if any host is unreachable
              fail:
                  msg: 'Host is unreachable. Exiting because not all hosts are reachable.'
              when: result is failed

            - name: Gathering Facts
              setup:
              ignore_errors: false

            - name: Gathering Facts
              setup:
              ignore_errors: false
        tags: reload

      - name: Setup Current Directory and Destination Directory
        block:
            - name: Get Current Directory
              command: pwd
              register: current_dir_output
              changed_when: false
              ignore_errors: true

            - name: Debug Current Directory
              debug:
                  var: current_dir_output.stdout

            - name: Set Destination Directory
              set_fact:
                  dest_directory: '{{ current_dir_output.stdout }}/navidec'
              changed_when: false

            - name: Debug Destination Directory
              debug:
                  var: dest_directory

            - name: Add alias 'cls' for 'clear' command
              ansible.builtin.lineinfile:
                  path: '{{ current_dir_output.stdout }}/.bashrc'
                  line: 'alias cls="clear"'
                  create: yes
              become: yes

            - name: Add alias 'd' for 'docker' command
              ansible.builtin.lineinfile:
                  path: '{{ current_dir_output.stdout }}/.bashrc'
                  line: 'alias d="docker"'
                  create: yes
              become: yes

            - name: Add alias 'k' for 'kubectl' command
              ansible.builtin.lineinfile:
                  path: '{{ current_dir_output.stdout }}/.bashrc'
                  line: 'alias k="kubectl"'
                  create: yes
              become: yes
        tags: reload

      - name: Prepare navidec directory
        block:
            - name: Delete old navidec directory
              file:
                  path: '{{ dest_directory }}'
                  state: absent
              become: yes
              ignore_errors: false

            - name: Clone navidec repository for localhost boat
              git:
                  repo: 'https://gitlab.inria.fr/muhammad.al-qabbani/navidec.git'
                  dest: '{{ current_dir_output.stdout }}/navidec'
                  version: '{{ boat_branch }}'
                  depth: 1
                  force: yes
                  update: yes
              when: "'boat_group' in group_names"

            - name: Clone navidec repository for land
              git:
                  repo: 'https://gitlab.inria.fr/muhammad.al-qabbani/navidec.git'
                  dest: '{{ current_dir_output.stdout }}/navidec'
                  version: '{{ land_branch }}'
                  depth: 1
                  force: yes
                  update: yes
              when: "'land_group' in group_names"
        tags: reload

      - name: extract infos to .env files
        block:
            - name: Get hostname
              command: hostname
              register: host_hostname_raw
              changed_when: false
              when: "'boat_group' in group_names or 'land_group' in group_names"

            - name: Get public IP address
              uri:
                  url: http://ipinfo.io/ip
                  return_content: yes
              register: host_ip
              changed_when: false
              when: "'boat_group' in group_names or 'land_group' in group_names"

            - name: Display hostname and IP address for current host
              debug:
                  msg:
                      - 'HOST_HOSTNAME_{{ inventory_hostname | upper }}={{ hostvars[inventory_hostname]["host_hostname_raw"]["stdout"] }}'
                      - 'HOST_IP_{{ inventory_hostname | upper }}={{ hostvars[inventory_hostname]["host_ip"]["content"] }}'

            - name: Debug Environment Variables
              debug:
                  msg: "HOST_IP_LAND={{ lookup('env', 'HOST_IP_LAND') }}, LAND_SSH_USER={{ lookup('env','LAND_SSH_USER') }}, LAND_SSH_PASS={{ lookup('env','LAND_SSH_PASS') }}"

            - name: Debug environment variables
              debug:
                  msg: 'HOST_IP_LAND={{ HOST_IP_LAND }} (type: {{ HOST_IP_LAND | type_debug }})'

            - name: Debug SSH user
              debug:
                  msg: 'LAND_SSH_USER={{ LAND_SSH_USER }} (type: {{ LAND_SSH_USER | type_debug }})'

            - name: Ensure Python 3 is available
              raw: which python3
              register: python3_available
              ignore_errors: yes

            - name: Install Python 3 if not available
              raw: apt-get install -y python3
              when: python3_available.rc != 0
              become: yes

            - name: Set Python interpreter
              set_fact:
                  ansible_python_interpreter: /usr/bin/python3
              when: python3_available.rc == 0

            - name: Gather facts from all hosts
              setup:
              ignore_errors: false

            - name: Ping all hosts
              ping:
              register: result
              ignore_errors: false

            - name: Fail if any host is unreachable
              fail:
                  msg: 'Host is unreachable. Exiting because not all hosts are reachable.'
              when: result is failed

            # - name: Gather facts from all hosts
            #   setup:
            #   delegate_to: '{{ item }}'
            #   delegate_facts: true
            #   loop: "{{ groups['all'] }}"

            - name: Remove existing .env file
              ansible.builtin.file:
                  path: '{{ dest_directory }}/.env'
                  state: absent
              delegate_to: boat
              run_once: true
              ignore_errors: true

            - name: Write hostname and IP address to multiple .env files for boat
              copy:
                  dest: '{{ item }}'
                  content: |
                      HOST_HOSTNAME_BOAT={{ hostvars["boat"]["host_hostname_raw"]["stdout"] }}
                      HOST_IP_BOAT={{ lookup('env', 'HOST_IP_BOAT') }}
                      HOST_HOSTNAME_LAND={{ hostvars["land"]["host_hostname_raw"]["stdout"] }}
                      HOST_IP_LAND={{ lookup('env', 'HOST_IP_LAND') }}
                      LAND_SSH_USER={{ lookup('env','LAND_SSH_USER') }}
                      LAND_SSH_PASS={{ lookup('env','LAND_SSH_PASS') }}
                      HOST_IP_RPC={{ lookup('env', 'HOST_IP_RPC') }}
                  force: yes
                  mode: '0644'
              loop:
                  - '{{ dest_directory }}/.env'
                  - '{{ dest_directory }}/xterm.js/.env'
                  - '{{ dest_directory }}/bandwidthvisualization/.env'
                  - '{{ dest_directory }}/streamonitor/.env'
                  - '{{ dest_directory }}/web_launcher/.env'
              delegate_to: boat
              run_once: true

            - name: Write hostname and IP address to .env file for land
              copy:
                  dest: '{{ dest_directory }}/.env'
                  content: |
                      HOST_IP_LAND: "{{ lookup('env', 'HOST_IP_LAND') }}"
                      HOST_IP_BOAT: "{{ lookup('env', 'HOST_IP_BOAT') }}"
                      HOST_HOSTNAME_LAND={{ hostvars["land"]["host_hostname_raw"]["stdout"] }}
                      HOST_HOSTNAME_BOAT={{ hostvars["boat"]["host_hostname_raw"]["stdout"] }}
                  force: yes
                  mode: '0644'
              when: "'land_group' in group_names"
        tags: reload

      - name: Ensure git and Docker are installed
        block:
            # - name: Update package repositories
            #   apt:
            #       update_cache: yes
            #   when: ansible_os_family == "Debian"
            #   become: yes

            - name: Update package repositories
              apt:
                  update_cache: yes
              become: "{{ 'local' not in ansible_connection }}"
              become_user: "{{ lookup('env', 'LAND_SSH_USER') }}"
              when: ansible_os_family == "Debian"

            - name: Install git
              package:
                  name: git
                  state: present

            - name: Check if Docker is installed
              shell: command -v docker
              register: docker_installed
              failed_when: docker_installed.rc != 0 and 'command not found' in docker_installed.stderr
              ignore_errors: true

            - name: Display message if Docker is installed
              debug:
                  msg: 'Docker is already installed'
              when: docker_installed.rc == 0

            - name: Download Docker installation script
              get_url:
                  url: https://get.docker.com
                  dest: /tmp/get-docker.sh
                  mode: '0755'
              when: ansible_os_family == "Debian" and docker_installed.rc != 0

            - name: Run Docker installation script
              command: sh /tmp/get-docker.sh
              when: ansible_os_family == "Debian" and docker_installed.rc != 0

            - name: Check if current user is in Docker group
              shell: id -nG "{{ ansible_env.USER }}" | grep -qw docker
              register: user_in_docker_group
              failed_when: user_in_docker_group.rc != 0 and 'docker' in user_in_docker_group.stdout

            - name: Display message if current user is in Docker group
              debug:
                  msg: 'Current user is already in Docker group'
              when: user_in_docker_group.rc == 0

            - name: Display message if current user is not in Docker group
              debug:
                  msg: 'Current user is not in Docker group'
              when: user_in_docker_group.rc != 0

            - name: Add current user to Docker group
              user:
                  name: '{{ ansible_env.USER }}'
                  groups: docker
                  append: yes
              when: user_in_docker_group.rc != 0

            - name: Instruct user to switch to new Docker group
              debug:
                  msg: 'Please open a new terminal to activate the Docker group'
              when: user_in_docker_group.rc != 0
        tags: initiate

      - name: Setup Python3 and Docker SDK
        block:
            - name: Check if Python3 is installed
              shell: command -v python3
              register: python3_installed
              ignore_errors: true

            - name: Display message if Python3 is installed
              debug:
                  msg: 'Python3 is already installed'
              when: python3_installed.rc == 0

            - name: Ensure Python3 is installed
              package:
                  name: python3
                  state: present
              when: ansible_os_family == "Debian" and python3_installed.rc != 0

            - name: Check if pip3 is installed
              shell: command -v pip3
              register: pip3_installed
              failed_when: pip3_installed.rc != 0 and 'command not found' in pip3_installed.stderr
              ignore_errors: true

            - name: Check pip3 installation status
              debug:
                  msg: "{{ 'pip3 is already installed' if pip3_installed.rc == 0 else 'pip3 is not installed.' }}"

            - name: Ensure pip3 is installed
              apt:
                  name: python3-pip
                  state: present
              when: ansible_os_family == "Debian" and pip3_installed.rc != 0

            - name: Check if Docker SDK for Python is installed
              shell: python3 -c "import docker"
              register: docker_sdk_installed
              failed_when: docker_sdk_installed.rc != 0 and 'No module named \'docker\'' not in docker_sdk_installed.stderr
              ignore_errors: true

            - name: Check Docker SDK for Python installation status
              debug:
                  msg: "{{ 'Docker SDK for Python is already installed' if docker_sdk_installed.rc == 0 else 'Docker SDK for Python is not installed.' }}"

            - name: Ensure Docker SDK for Python is installed
              pip:
                  name: docker
                  state: present
                  executable: pip3
              when: docker_sdk_installed.rc != 0
        tags: initiate

      - name: Check and install k3s
        block:
            - name: Check if k3s is running
              shell: systemctl is-active --quiet k3s && echo 'active' || echo 'inactive'
              register: k3s_status
              failed_when: k3s_status.rc != 0 and 'inactive' not in k3s_status.stdout
              ignore_errors: true

            - name: Display k3s status
              debug:
                  msg: "{{ 'k3s is running' if k3s_status.stdout == 'active' else 'k3s is not running' }}"

            - name: Install k3s on boat if not running
              shell: >
                  {% set target_ip = HOST_IP_BOAT %}
                  {% set INSTALL_K3S_EXEC = "--tls-san " + target_ip %}
                  curl -sfL https://get.k3s.io | INSTALL_K3S_EXEC="${{ INSTALL_K3S_EXEC }}" sh -
              args:
                  warn: false
              when: k3s_status.stdout != 'active' and inventory_hostname in groups['boat_group']

            - name: Install k3s on land if not running
              shell: >
                  {% set target_ip = HOST_IP_LAND %}
                  {% set INSTALL_K3S_EXEC = "--tls-san " + target_ip %}
                  curl -sfL https://get.k3s.io | INSTALL_K3S_EXEC="${{ INSTALL_K3S_EXEC }}" sh -
              args:
                  warn: false
              when: k3s_status.stdout != 'active' and inventory_hostname in groups['land_group']
        tags: initiate

      - name: K3s configuration block
        block:
            - name: Check if k3s is running
              shell: systemctl is-active --quiet k3s && echo 'active' || echo 'inactive'
              register: k3s_status

            - name: Copy k3s.yaml to multiple destinations on boat
              copy:
                  src: /etc/rancher/k3s/k3s.yaml
                  dest: '{{ item }}'
                  force: yes
                  mode: '0644'
              loop:
                  - '{{ dest_directory }}/k3s.yaml'
                  - '{{ dest_directory }}/bandwidthvisualization/k3s.yaml'
                  - '{{ dest_directory }}/streamonitor/k3s.yaml'
              when: "'boat_group' in group_names"

            - name: Copy k3s.yaml to destination directory on land
              copy:
                  src: /etc/rancher/k3s/k3s.yaml
                  dest: '{{ dest_directory }}/k3s.yaml'
                  force: yes
                  mode: '0644'
                  remote_src: yes
              when: "'land_group' in group_names"

            - name: Replace IP address in k3s.yaml for boat group
              replace:
                  path: '{{ item }}'
                  regexp: 'server: https://127.0.0.1:6443'
                  replace: 'server: https://{{ HOST_IP_BOAT }}:6443'
              loop:
                  - '{{ dest_directory }}/k3s.yaml'
                  - '{{ dest_directory }}/bandwidthvisualization/k3s.yaml'
                  - '{{ dest_directory }}/streamonitor/k3s.yaml'
              when: "'boat_group' in group_names"

            - name: Replace IP address in k3s.yaml for land group
              replace:
                  path: '{{ dest_directory }}/k3s.yaml'
                  regexp: 'server: https://127.0.0.1:6443'
                  replace: 'server: https://{{ HOST_IP_LAND }}:6443'
              when: "'land_group' in group_names"
        tags: reload

      - name: Clean K8s deployments
        block:
            - name: Check if deployments exist
              shell: kubectl get deployment streaming; kubectl get deployment classifier
              register: deployment_result
              failed_when: false
              environment:
                  KUBECONFIG: /etc/rancher/k3s/k3s.yaml

            - name: Check if services exist
              shell: kubectl get service streaming-service; kubectl get service classifier-service
              register: service_result
              failed_when: false
              environment:
                  KUBECONFIG: /etc/rancher/k3s/k3s.yaml

            - name: Delete K8s deployments
              shell: |
                  kubectl delete deployment streaming
                  kubectl delete deployment classifier
              become: yes
              when: "'NotFound' not in deployment_result.stderr"
              environment:
                  KUBECONFIG: /etc/rancher/k3s/k3s.yaml

            - name: Delete K8s services
              shell: |
                  kubectl delete service streaming-service
                  kubectl delete service classifier-service
              become: yes
              when: "'NotFound' not in service_result.stderr"
              environment:
                  KUBECONFIG: /etc/rancher/k3s/k3s.yaml
        tags: initiate
      # =========================== Do Not Delete it ==================================
      - name: Ensure openvpnas is installed
        block:
            - name: Gather package facts
              package_facts:
                  manager: auto

            - name: Check if openvpn or openvpnas is installed
              set_fact:
                  vpn_installed: "{{ 'openvpn' in ansible_facts.packages or 'openvpnas' in ansible_facts.packages }}"

            - name: Display message if openvpn or openvpnas is installed
              debug:
                  msg: 'openvpn or openvpnas is already installed'
              when: vpn_installed

            - name: Display message if openvpn or openvpnas is not installed
              debug:
                  msg: 'openvpn or openvpnas is not installed'
              when: not vpn_installed
        when: "'boat_group' in group_names"
        tags: initiate

      - name: Install OpenVPN
        become: yes
        block:
            - name: Update packages
              apt:
                  update_cache: yes

            - name: Install required packages
              apt:
                  name:
                      - ca-certificates
                      - wget
                      - curl
                      - net-tools
                      - gnupg
                  state: present

            - name: Add OpenVPN repository key
              become: yes
              get_url:
                  url: https://as-repository.openvpn.net/as-repo-public.asc
                  dest: /etc/apt/trusted.gpg.d/as-repository.asc

            - name: Add OpenVPN repository for Ubuntu 22, 64 bits
              become: yes
              copy:
                  content: 'deb [arch=amd64 signed-by=/etc/apt/trusted.gpg.d/as-repository.asc] http://as-repository.openvpn.net/as/debian jammy main'
                  dest: /etc/apt/sources.list.d/openvpn-as-repo.list
              when: ansible_distribution == "Ubuntu" and ansible_distribution_version.startswith('22') and ansible_architecture == 'x86_64'

            - name: Add OpenVPN repository for Ubuntu 22, ARM64
              become: yes
              copy:
                  content: 'deb [arch=arm64 signed-by=/etc/apt/trusted.gpg.d/as-repository.asc] http://as-repository.openvpn.net/as/debian jammy main'
                  dest: /etc/apt/sources.list.d/openvpn-as-repo.list
              when: ansible_distribution == "Ubuntu" and ansible_distribution_version.startswith('22') and ansible_architecture == 'aarch64'

            - name: Add OpenVPN repository for Ubuntu 20, 64 bits
              become: yes
              copy:
                  content: 'deb [arch=amd64 signed-by=/etc/apt/trusted.gpg.d/as-repository.asc] http://as-repository.openvpn.net/as/debian focal main'
                  dest: /etc/apt/sources.list.d/openvpn-as-repo.list
              when: ansible_distribution == "Ubuntu" and ansible_distribution_version.startswith('20') and ansible_architecture == 'x86_64'

            - name: Add OpenVPN repository for Ubuntu 20, ARM64
              become: yes
              copy:
                  content: 'deb [arch=arm64 signed-by=/etc/apt/trusted.gpg.d/as-repository.asc] http://as-repository.openvpn.net/as/debian focal main'
                  dest: /etc/apt/sources.list.d/openvpn-as-repo.list
              when: ansible_distribution == "Ubuntu" and ansible_distribution_version.startswith('20') and ansible_architecture == 'aarch64'

            - name: Add OpenVPN repository for Debian 10, 64 bits
              become: yes
              copy:
                  content: 'deb [arch=amd64 signed-by=/etc/apt/trusted.gpg.d/as-repository.asc] http://as-repository.openvpn.net/as/debian buster main'
                  dest: /etc/apt/sources.list.d/openvpn-as-repo.list
              when: ansible_distribution == "Debian" and ansible_distribution_version.startswith('10') and ansible_architecture == 'x86_64'

            - name: Add OpenVPN repository for Debian 11, 64 bits
              become: yes
              copy:
                  content: 'deb [arch=amd64 signed-by=/etc/apt/trusted.gpg.d/as-repository.asc] http://as-repository.openvpn.net/as/debian bullseye main'
                  dest: /etc/apt/sources.list.d/openvpn-as-repo.list
              when: ansible_distribution == "Debian" and ansible_distribution_version.startswith('11') and ansible_architecture == 'x86_64'

            - name: Add OpenVPN repository for Debian 12, 64 bits
              become: yes
              copy:
                  content: 'deb [arch=amd64 signed-by=/etc/apt/trusted.gpg.d/as-repository.asc] http://as-repository.openvpn.net/as/debian bookworm main'
                  dest: /etc/apt/sources.list.d/openvpn-as-repo.list
              when: ansible_distribution == "Debian" and ansible_distribution_version.startswith('12') and ansible_architecture == 'x86_64'

            - name: Update package lists after adding new repository
              become: yes
              apt:
                  update_cache: yes

            - name: Install OpenVPN
              become: yes
              command: apt -y install openvpn-as
              register: install_output

            - name: Display installation output
              become: yes
              debug:
                  var: install_output.stdout_lines

            - name: Set hostname IP
              become: yes
              command: "/usr/local/openvpn_as/scripts/sacli --key 'host.name' --value '{{ hostvars['boat']['host_ip']['content'] | trim }}' ConfigPut"
              register: result_net

            - name: Set vpn.server.group_pool
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --key "vpn.server.group_pool.0" --value "172.0.0.0/8" ConfigPut

            - name: Set tcp.n_daemons
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli -k vpn.server.daemon.tcp.n_daemons -v 4 configput

            - name: Set udp.n_daemons
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli -k vpn.server.daemon.udp.n_daemons -v 4 configput

            - name: Set static network
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --key "vpn.server.static.0.network" --value "10.10.0.0" ConfigPut
              register: result_net

            - name: Set netmask bits
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --key "vpn.server.static.0.netmask_bits" --value "16" ConfigPut
              register: result_bits

            - name: Set private subnet
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --key "vpn.server.routing.private_access" --value "no" ConfigPut
              register: result_private_subnet

            - name: Restart OpenVPN Access Server
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli start
              when: result_net.rc == 0 and result_bits.rc == 0

            - name: Set client Internet traffic be routed through the VPN as false
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --key "vpn.client.routing.reroute_gw" --value "false" ConfigPut

            - name: Do not alter clients' DNS server settings
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --key "vpn.client.routing.reroute_dns" --value "false" ConfigPut

            - name: Restart OpenVPN Access Server
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli start

            - name: Set autologin for user "{{ openvpn_user1_username }}"
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --user "{{ openvpn_user1_username }}" --key "type" --value "user_connect" --key "prop_autologin" --value "true" UserPropPut

            - name: Change the password for user "{{ openvpn_user1_username }}"
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --user "{{ openvpn_user1_username }}" --new_pass "{{ openvpn_user1_password }}" SetLocalPassword

            - name: Set connection IP for user "{{ openvpn_user1_username }}"
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --user "{{ openvpn_user1_username }}" --key "conn_ip" --value {{ openvpn_user1_ip }} UserPropPut

            - name: Restart OpenVPN Access Server
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli start

            - name: Set autologin for user "{{ openvpn_user2_username }}"
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --user "{{ openvpn_user2_username }}" --key "type" --value "user_connect" --key "prop_autologin" --value "true" UserPropPut

            - name: Change the password for user "{{ openvpn_user2_username }}"
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --user "{{ openvpn_user2_username }}" --new_pass "{{ openvpn_user1_password }}" SetLocalPassword

            - name: Set connection IP for user "{{ openvpn_user2_username }}"
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --user "{{ openvpn_user2_username }}" --key "conn_ip" --value {{ openvpn_user2_ip }} UserPropPut

            - name: Restart OpenVPN Access Server
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli start

            - name: Set user as a superuser
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --user "{{ openvpn_admin_username }}" --key "prop_superuser" --value "true" UserPropPut

            - name: Set user authentication type to local
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --user "{{ openvpn_admin_username }}" --key "user_auth_type" --value "local" UserPropPut

            - name: Change the password for the OpenVPN admin user
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli --user "{{ openvpn_admin_username }}" --new_pass "{{ openvpn_admin_password }}" SetLocalPassword

            - name: Start OpenVPN Access Server
              become: yes
              command: /usr/local/openvpn_as/scripts/sacli start

            - name: Display OpenVPN admin username and password
              become: yes
              debug:
                  msg: 'OpenVPN Admin Username: {{ openvpn_admin_username }}, OpenVPN Admin Password: {{ openvpn_admin_password }}'

            - name: Display OpenVPN username and password for user 1
              become: yes
              debug:
                  msg: 'OpenVPN Username: {{ openvpn_user1_username }}, OpenVPN Password: {{ openvpn_user1_password }}'

            - name: Display OpenVPN username and password for user 2
              become: yes
              debug:
                  msg: 'OpenVPN Username: {{ openvpn_user2_username }}, OpenVPN Password: {{ openvpn_user2_password }}'

            - name: Display Admin and Client UI URLs
              become: yes
              debug:
                  msg:
                      - 'openvpn Access Server Web UIs are available here:'
                      - 'Admin UI: https://{{ hostvars["boat"]["host_ip"]["content"] }}:943/admin'
                      - 'Client UI: https://{{ hostvars["boat"]["host_ip"]["content"] }}:943/'
        when: "'boat_group' in group_names and not vpn_installed"
        tags: initiate

      - name: Prepare docker containers services
        block:
            - name: Docker compose down and remove images and volume
              shell: |
                  docker compose down --remove-orphans --rmi all -v
                  docker compose rm
              args:
                  chdir: '{{ dest_directory }}'
              become: yes
              ignore_errors: true

            - name: Check for running Docker containers
              shell: docker ps -a -q
              register: docker_containers
              ignore_errors: true

            - name: Stop and remove all Docker containers
              shell: |
                  docker stop {{ docker_containers.stdout_lines | join(' ') }}
                  docker rm {{ docker_containers.stdout_lines | join(' ') }}
              when: docker_containers.stdout_lines | length > 0
              become: yes
              ignore_errors: true

            # - name: Stop and remove all Docker containers
            #   shell: |
            #     docker stop $(docker ps -a -q)
            #     docker rm $(docker ps -a -q)
            #   become: yes
            #   ignore_errors: true

            - name: Remove Docker volumes
              shell: docker volume prune -f
              become: yes
              ignore_errors: true

            # - name: Remove dangling Docker images
            #   shell: docker rmi $(docker images -f "dangling=true" -q)
            #   ignore_errors: true

            - name: Check for dangling Docker images
              shell: docker images -f "dangling=true" -q
              register: dangling_images
              ignore_errors: true

            - name: Remove dangling Docker images
              shell: docker rmi {{ dangling_images.stdout_lines | join(' ') }}
              when: dangling_images.stdout_lines | length > 0
              ignore_errors: true

            - name: Remove unused Docker data
              shell: docker system prune -a --volumes -f
              ignore_errors: true

            - name: Docker compose up
              command:
                  chdir: '{{ dest_directory }}'
                  cmd: docker compose up -d --build --force-recreate
              become: yes
              ignore_errors: true
        when: "'boat_group' in group_names or 'land_group' in group_names"
        tags: reload
